907. Sum of Subarray Minimums | Monotonic Stack | Brute - Better - Optimal

  Рет қаралды 16,090

Aryan Mittal

Aryan Mittal

Күн бұрын

Пікірлер: 42
@ARYANMITTAL
@ARYANMITTAL 10 ай бұрын
Don't know what LC smoked, before placing this Problem as Medium 🫠🫠
@infinitysoundmotivation9768
@infinitysoundmotivation9768 4 ай бұрын
Weed 😢
@gdivya1895
@gdivya1895 10 ай бұрын
This question ate my brain for the past two hours, I've tried all other videos available for this question, including big names like neetcode, but your solution is the only one that I could understand from start to finish. Well done sir. Earned a subscribe.
@manwinsingh7381
@manwinsingh7381 10 ай бұрын
Same here
@dhushyanthankannan8856
@dhushyanthankannan8856 4 ай бұрын
This is the greatest explanation among all the explanations available in yt
@madhubala5655
@madhubala5655 6 ай бұрын
Finally after watching the solution in 4 different channels I understood it here
@mcw0805
@mcw0805 10 ай бұрын
Thank you so much for explaining HOW the count works. I was trying to recall what I learned in my combinatorics class years ago lol
@homeroserna9983
@homeroserna9983 8 ай бұрын
Great solution. I like how you worked out the problem step by step completely before going to the code. You made a hard problem seem easy.
@k.k.harjeeth5422
@k.k.harjeeth5422 4 ай бұрын
24:06 this was brilliant !
@gonuguntlakoushik899
@gonuguntlakoushik899 10 ай бұрын
loved your way of explanation❤
@jjjyotijain
@jjjyotijain 8 ай бұрын
bro, what an amazing explanation. now I don't have any doubt left after watching this video. and now I can easily solve the problems of same pattern. Thank you very much for such a great explanation😍👏👏.
@tejaschalke1778
@tejaschalke1778 10 ай бұрын
I was pissed I couldn't solve this problem but, now I feel a little better considering how hard this was. Also please make a video on KMP 😮‍💨, waiting from the previous weekly contest.
@ARYANMITTAL
@ARYANMITTAL 10 ай бұрын
That video is out bro, that day only it came - Write on yt - Kmp by Aryan Mittal, you will get the video ❤️❤️🫂
@tejaschalke1778
@tejaschalke1778 10 ай бұрын
@@ARYANMITTAL damn i completely missed it 😅.
@juliankuhn9742
@juliankuhn9742 10 ай бұрын
thank you this is the best explanation I found :)
@saurabhchaudhari4157
@saurabhchaudhari4157 5 ай бұрын
class Solution { private: vector prevSmaller(vector&arr){ int n=arr.size(); vectorans(n); stackst; for(int i=0;ielm){ st.pop(); } //empty if(st.empty()){ ans[i]=-1; } else{ ans[i]=st.top(); } st.push(i); } //push return ans; } vector nextSmaller(vector&arr){ int n=arr.size(); vectorans(n); stackst; for(int i=n-1;i>=0;i--){ int elm=arr[i]; //pop while(!st.empty() && arr[st.top()]>=elm){ st.pop(); } //empty if(st.empty()){ ans[i]=-1; } else{ ans[i]=st.top(); } //push st.push(i); } return ans; } public: int sumSubarrayMins(vector& arr) { int n=arr.size(); int MOD = 1000000007; vectornext=nextSmaller(arr); vectorprev=prevSmaller(arr);; long long sum=0; for(int i=0;i
@sagarsaini5377
@sagarsaini5377 4 ай бұрын
finally a good explaination.
@physicstyco8631
@physicstyco8631 3 ай бұрын
amazing explanation bro
@ohhpeejoshi9110
@ohhpeejoshi9110 4 ай бұрын
thankyou so much buddy! very nice
@mrityunjoybarman9098
@mrityunjoybarman9098 10 ай бұрын
Actually I'm not good at hard problems but after reading the problem I don't know how it clicked my mind and cracked the monotonic stack solution.
@k.satish3663
@k.satish3663 10 ай бұрын
totally understood ! thank you so much bro
@codeman0017
@codeman0017 9 ай бұрын
#include #include #include using namespace std; class Solution { public: int sumSubarrayMins(vector& arr) { stack st; vector next_lesser(arr.size(), arr.size()); vector prev_lesser(arr.size(), -1); for (int i = 0; i < arr.size(); i++) { while (!st.empty() && arr[st.top()] >= arr[i]) { next_lesser[st.top()] = i; st.pop(); } prev_lesser[i] = st.empty() ? -1 : st.top(); st.push(i); } long long answer = 0; double mod = 1e9 + 7; for (int i = 0; i < arr.size(); i++) { long long left = i - prev_lesser[i]; long long right = next_lesser[i] - i; answer += arr[i] * left * right; answer %= (long long)mod; } return (int)answer; } }; int main() { Solution sol; vector arr = {3, 1, 2, 4}; cout
@lohithaadapala6989
@lohithaadapala6989 4 ай бұрын
Excellent!
@aa_maruf
@aa_maruf 10 ай бұрын
Brilliant explanation♥
@janardhan2jordan
@janardhan2jordan 6 ай бұрын
I cant get a hold on why left*right works i get that it tells us that how many subarrays will include that particular number, but cant understand why it works?? anyone explain if possible, Great video by the way....Clear and precise.
@kannank4269
@kannank4269 10 ай бұрын
How aryan can maintain work n leetcode parallely
@jaatharsh
@jaatharsh 10 ай бұрын
superb explanation, really like it (tired of python explanation :D)
@mdsajidanwar6416
@mdsajidanwar6416 10 ай бұрын
Given constraint is 3x10^4 , then O(n^2) should work then why it's TLE showing
@josephsamuelm4608
@josephsamuelm4608 10 ай бұрын
Bro can u solve Sum of Subarray Ranges as well. Thanks in advance !
@deepneurallearner
@deepneurallearner 7 ай бұрын
Bhai aapne cnt ko tho badhaya hi nahi jab voh while loop main nahi ghus raha hai tab???
@gaishurajput8239
@gaishurajput8239 10 ай бұрын
Showing TLE
@aryansonwani7061
@aryansonwani7061 10 ай бұрын
did it by myself in half hour
@aryansonwani7061
@aryansonwani7061 10 ай бұрын
stack st; st.push(-1); int n=arr.size(); vector dp(n); long long ans=0; for(int i=0;iarr[i-1]) dp[i]=(arr[i]+dp[i-1]); else { // 2nd case while(st.top()!=-1 and arr[i]
@blackvelta1913
@blackvelta1913 10 ай бұрын
bro can you explain it please
@YashGulhane-uv9yf
@YashGulhane-uv9yf 3 ай бұрын
watched
@gauristar4094
@gauristar4094 6 ай бұрын
thanksssss
@AkashDeep-jp1ts
@AkashDeep-jp1ts 7 ай бұрын
Fucked up my mind!
@samiranroyy1700
@samiranroyy1700 3 ай бұрын
🧡❤❤❤❤❤❤❤❤❤
@ishanbhardwaj6082
@ishanbhardwaj6082 10 ай бұрын
Correct me if I'm wrong, but I believe the code fails for brute and better. Because it is not taking into account single element subarrays. Thank you for the stack solution tho, I was stuck on it the whole day lol
@abc-ym4zs
@abc-ym4zs 10 ай бұрын
bhaiya to improve logical thinking should i need to do cp bhaiya i am in third year i am not getting interest any tips bhaiya
@veekykumar4211
@veekykumar4211 8 ай бұрын
Why Wrong Answer Runtime: 7 ms Case 1 Case 2 Input arr = [11,81,94,43,3] Output 384 Expected 444 class Solution { public: int sumSubarrayMins(vector& arr) { int MOD = 1e9 + 7; int n = arr.size(); vector left(n,0), right(n,0); stacksLeft, sRight; for(int i=0;iarr[i]){ cnt+=sLeft.top().second; sLeft.pop(); } sLeft.push({arr[i],cnt}); left[i]=cnt; } for(int i=n-1;i>=0;i--){ int cnt=1; if(!sRight.empty() && sRight.top().first>=arr[i]){ cnt+=sRight.top().second; sRight.pop(); } sRight.push({arr[i],cnt}); right[i]=cnt; } long long sum = 0; for(int i=0;i
When Cucumbers Meet PVC Pipe The Results Are Wild! 🤭
00:44
Crafty Buddy
Рет қаралды 60 МЛН
Smart Sigma Kid #funny #sigma
00:33
CRAZY GREAPA
Рет қаралды 7 МЛН
Sum of Subarray Minimums - Leetcode 907 - Python
18:51
NeetCodeIO
Рет қаралды 35 М.
979. Distribute Coins in Binary Tree | Tricky DFS | Recursion
17:24
Aryan Mittal
Рет қаралды 4,7 М.
L10. Sum of subarray ranges | Stack and Queue Playlist
10:34
take U forward
Рет қаралды 28 М.
907. Sum of Subarray Minimums || Leetcode Daily challenge
12:31
Sanjay Prajapati
Рет қаралды 692
Sum of Subarray Minimums | Detailed | Leetcode 907
49:39
codestorywithMIK
Рет қаралды 26 М.
739. Daily Temperatures | Monotonic Stack | Space Optimisation O(1)
28:11
Monotonic Stack Data Structure Explained
5:43
AlgoMonster
Рет қаралды 48 М.
When Cucumbers Meet PVC Pipe The Results Are Wild! 🤭
00:44
Crafty Buddy
Рет қаралды 60 МЛН